<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxGeometry (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
<script type="text/javascript" src="../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxGeometry (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGeometry.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">hk.quantr.mxgraph.model</a></div>
<h2 title="Class mxGeometry" class="title">Class mxGeometry</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">hk.quantr.mxgraph.util.mxPoint</a></li>
<li>
<ul class="inheritance">
<li><a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">hk.quantr.mxgraph.util.mxRectangle</a></li>
<li>
<ul class="inheritance">
<li>hk.quantr.mxgraph.model.mxGeometry</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><code>java.io.Serializable</code>, <code>java.lang.Cloneable</code></dd>
</dl>
<hr>
<pre>public class <span class="typeNameLabel">mxGeometry</span>
extends <a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></pre>
<div class="block">Represents the geometry of a cell. For vertices, the geometry consists
 of the x- and y-location, as well as the width and height. For edges,
 the geometry either defines the source- and target-terminal, or it
 defines the respective terminal points.
 
 For edges, if the geometry is relative (default), then the x-coordinate
 is used to describe the distance from the center of the edge from -1 to 1
 with 0 being the center of the edge and the default value, and the
 y-coordinate is used to describe the absolute, orthogonal distance in
 pixels from that point. In addition, the offset is used as an absolute
 offset vector from the resulting point.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../serialized-form.html#hk.quantr.mxgraph.model.mxGeometry">Serialized Form</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#alternateBounds">alternateBounds</a></span></code></th>
<td class="colLast">
<div class="block">Stores alternate values for x, y, width and height in a rectangle.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#offset">offset</a></span></code></th>
<td class="colLast">
<div class="block">Holds the offset of the label for edges.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#points">points</a></span></code></th>
<td class="colLast">
<div class="block">List of mxPoints which specifies the control points along the edge.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#relative">relative</a></span></code></th>
<td class="colLast">
<div class="block">Specifies if the coordinates in the geometry are to be interpreted as
 relative coordinates.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected <a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sourcePoint">sourcePoint</a></span></code></th>
<td class="colLast">
<div class="block">Defines the source- and target-point of the edge.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected <a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#targetPoint">targetPoint</a></span></code></th>
<td class="colLast">
<div class="block">Defines the source- and target-point of the edge.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#TRANSLATE_CONTROL_POINTS">TRANSLATE_CONTROL_POINTS</a></span></code></th>
<td class="colLast">
<div class="block">Global switch to translate the points in translate.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="fields.inherited.from.class.hk.quantr.mxgraph.util.mxRectangle">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></h3>
<code><a href="../util/mxRectangle.html#height">height</a>, <a href="../util/mxRectangle.html#width">width</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="fields.inherited.from.class.hk.quantr.mxgraph.util.mxPoint">
<!--   -->
</a>
<h3>Fields inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></h3>
<code><a href="../util/mxPoint.html#x">x</a>, <a href="../util/mxPoint.html#y">y</a></code></li>
</ul>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">mxGeometry</a></span>()</code></th>
<td class="colLast">
<div class="block">Constructs a new geometry at (0, 0) with the width and height set to 0.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(double,double,double,double)">mxGeometry</a></span>&#8203;(double&nbsp;x,
          double&nbsp;y,
          double&nbsp;width,
          double&nbsp;height)</code></th>
<td class="colLast">
<div class="block">Constructs a geometry using the given parameters.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>java.lang.Object</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#clone()">clone</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns a clone of the cell.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getAlternateBounds()">getAlternateBounds</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the alternate bounds.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getOffset()">getOffset</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the offset.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getPoints()">getPoints</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the list of control points.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSourcePoint()">getSourcePoint</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the source point.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTargetPoint()">getTargetPoint</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns the target point.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTerminalPoint(boolean)">getTerminalPoint</a></span>&#8203;(boolean&nbsp;isSource)</code></th>
<td class="colLast">
<div class="block">Returns the point representing the source or target point of this edge.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#isRelative()">isRelative</a></span>()</code></th>
<td class="colLast">
<div class="block">Returns true of the geometry is relative.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setAlternateBounds(hk.quantr.mxgraph.util.mxRectangle)">setAlternateBounds</a></span>&#8203;(<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a>&nbsp;rect)</code></th>
<td class="colLast">
<div class="block">Sets the alternate bounds to the given rectangle.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setOffset(hk.quantr.mxgraph.util.mxPoint)">setOffset</a></span>&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;offset)</code></th>
<td class="colLast">
<div class="block">Sets the offset to the given point.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setPoints(java.util.List)">setPoints</a></span>&#8203;(java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt;&nbsp;value)</code></th>
<td class="colLast">
<div class="block">Sets the list of control points to the given list.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setRelative(boolean)">setRelative</a></span>&#8203;(boolean&nbsp;value)</code></th>
<td class="colLast">
<div class="block">Sets the relative state of the geometry.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setSourcePoint(hk.quantr.mxgraph.util.mxPoint)">setSourcePoint</a></span>&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;sourcePoint)</code></th>
<td class="colLast">
<div class="block">Sets the source point.</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setTargetPoint(hk.quantr.mxgraph.util.mxPoint)">setTargetPoint</a></span>&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;targetPoint)</code></th>
<td class="colLast">
<div class="block">Sets the target point.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code><a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setTerminalPoint(hk.quantr.mxgraph.util.mxPoint,boolean)">setTerminalPoint</a></span>&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;point,
                boolean&nbsp;isSource)</code></th>
<td class="colLast">
<div class="block">Sets the sourcePoint or targetPoint to the given point and returns the
 new point.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#swap()">swap</a></span>()</code></th>
<td class="colLast">
<div class="block">Swaps the x, y, width and height with the values stored in
 alternateBounds and puts the previous values into alternateBounds as
 a rectangle.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#translate(double,double)">translate</a></span>&#8203;(double&nbsp;dx,
         double&nbsp;dy)</code></th>
<td class="colLast">
<div class="block">Translates the geometry by the specified amount.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.hk.quantr.mxgraph.util.mxRectangle">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></h3>
<code><a href="../util/mxRectangle.html#add(hk.quantr.mxgraph.util.mxRectangle)">add</a>, <a href="../util/mxRectangle.html#contains(double,double)">contains</a>, <a href="../util/mxRectangle.html#equals(java.lang.Object)">equals</a>, <a href="../util/mxRectangle.html#getCenterX()">getCenterX</a>, <a href="../util/mxRectangle.html#getCenterY()">getCenterY</a>, <a href="../util/mxRectangle.html#getHeight()">getHeight</a>, <a href="../util/mxRectangle.html#getRectangle()">getRectangle</a>, <a href="../util/mxRectangle.html#getWidth()">getWidth</a>, <a href="../util/mxRectangle.html#grow(double)">grow</a>, <a href="../util/mxRectangle.html#intersectLine(double,double,double,double)">intersectLine</a>, <a href="../util/mxRectangle.html#rotate90()">rotate90</a>, <a href="../util/mxRectangle.html#setHeight(double)">setHeight</a>, <a href="../util/mxRectangle.html#setRect(double,double,double,double)">setRect</a>, <a href="../util/mxRectangle.html#setWidth(double)">setWidth</a>, <a href="../util/mxRectangle.html#toString()">toString</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.hk.quantr.mxgraph.util.mxPoint">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;hk.quantr.mxgraph.util.<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a></h3>
<code><a href="../util/mxPoint.html#getPoint()">getPoint</a>, <a href="../util/mxPoint.html#getX()">getX</a>, <a href="../util/mxPoint.html#getY()">getY</a>, <a href="../util/mxPoint.html#setX(double)">setX</a>, <a href="../util/mxPoint.html#setY(double)">setY</a></code></li>
</ul>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="TRANSLATE_CONTROL_POINTS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>TRANSLATE_CONTROL_POINTS</h4>
<pre>public static transient&nbsp;boolean TRANSLATE_CONTROL_POINTS</pre>
<div class="block">Global switch to translate the points in translate. Default is true.</div>
</li>
</ul>
<a id="alternateBounds">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>alternateBounds</h4>
<pre>protected&nbsp;<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a> alternateBounds</pre>
<div class="block">Stores alternate values for x, y, width and height in a rectangle.
 Default is null.</div>
</li>
</ul>
<a id="sourcePoint">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sourcePoint</h4>
<pre>protected&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a> sourcePoint</pre>
<div class="block">Defines the source- and target-point of the edge. This is used if the
 corresponding edge does not have a source vertex. Otherwise it is
 ignored. Default is null.</div>
</li>
</ul>
<a id="targetPoint">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>targetPoint</h4>
<pre>protected&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a> targetPoint</pre>
<div class="block">Defines the source- and target-point of the edge. This is used if the
 corresponding edge does not have a source vertex. Otherwise it is
 ignored. Default is null.</div>
</li>
</ul>
<a id="points">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>points</h4>
<pre>protected&nbsp;java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt; points</pre>
<div class="block">List of mxPoints which specifies the control points along the edge.
 These points are the intermediate points on the edge, for the endpoints
 use targetPoint and sourcePoint or set the terminals of the edge to
 a non-null value. Default is null.</div>
</li>
</ul>
<a id="offset">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>offset</h4>
<pre>protected&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a> offset</pre>
<div class="block">Holds the offset of the label for edges. This is the absolute vector
 between the center of the edge and the top, left point of the label.
 Default is null.</div>
</li>
</ul>
<a id="relative">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>relative</h4>
<pre>protected&nbsp;boolean relative</pre>
<div class="block">Specifies if the coordinates in the geometry are to be interpreted as
 relative coordinates. Default is false. This is used to mark a geometry
 with an x- and y-coordinate that is used to describe an edge label
 position, or a relative location with respect to a parent cell's
 width and height.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>mxGeometry</h4>
<pre>public&nbsp;mxGeometry()</pre>
<div class="block">Constructs a new geometry at (0, 0) with the width and height set to 0.</div>
</li>
</ul>
<a id="&lt;init&gt;(double,double,double,double)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxGeometry</h4>
<pre>public&nbsp;mxGeometry&#8203;(double&nbsp;x,
                  double&nbsp;y,
                  double&nbsp;width,
                  double&nbsp;height)</pre>
<div class="block">Constructs a geometry using the given parameters.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>x</code> - X-coordinate of the new geometry.</dd>
<dd><code>y</code> - Y-coordinate of the new geometry.</dd>
<dd><code>width</code> - Width of the new geometry.</dd>
<dd><code>height</code> - Height of the new geometry.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getAlternateBounds()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAlternateBounds</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a>&nbsp;getAlternateBounds()</pre>
<div class="block">Returns the alternate bounds.</div>
</li>
</ul>
<a id="setAlternateBounds(hk.quantr.mxgraph.util.mxRectangle)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setAlternateBounds</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setAlternateBounds&#8203;(<a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a>&nbsp;rect)</pre>
<div class="block">Sets the alternate bounds to the given rectangle.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rect</code> - Rectangle to be used for the alternate bounds.</dd>
</dl>
</li>
</ul>
<a id="getSourcePoint()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSourcePoint</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;getSourcePoint()</pre>
<div class="block">Returns the source point.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the source point.</dd>
</dl>
</li>
</ul>
<a id="setSourcePoint(hk.quantr.mxgraph.util.mxPoint)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setSourcePoint</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setSourcePoint&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;sourcePoint)</pre>
<div class="block">Sets the source point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sourcePoint</code> - Source point to be used.</dd>
</dl>
</li>
</ul>
<a id="getTargetPoint()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTargetPoint</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;getTargetPoint()</pre>
<div class="block">Returns the target point.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the target point.</dd>
</dl>
</li>
</ul>
<a id="setTargetPoint(hk.quantr.mxgraph.util.mxPoint)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTargetPoint</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setTargetPoint&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;targetPoint)</pre>
<div class="block">Sets the target point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>targetPoint</code> - Target point to be used.</dd>
</dl>
</li>
</ul>
<a id="getPoints()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getPoints</h4>
<pre class="methodSignature">public&nbsp;java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt;&nbsp;getPoints()</pre>
<div class="block">Returns the list of control points.</div>
</li>
</ul>
<a id="setPoints(java.util.List)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setPoints</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setPoints&#8203;(java.util.List&lt;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&gt;&nbsp;value)</pre>
<div class="block">Sets the list of control points to the given list.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>value</code> - List that contains the new control points.</dd>
</dl>
</li>
</ul>
<a id="getOffset()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getOffset</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;getOffset()</pre>
<div class="block">Returns the offset.</div>
</li>
</ul>
<a id="setOffset(hk.quantr.mxgraph.util.mxPoint)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setOffset</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setOffset&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;offset)</pre>
<div class="block">Sets the offset to the given point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>offset</code> - Point to be used for the offset.</dd>
</dl>
</li>
</ul>
<a id="isRelative()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isRelative</h4>
<pre class="methodSignature">public&nbsp;boolean&nbsp;isRelative()</pre>
<div class="block">Returns true of the geometry is relative.</div>
</li>
</ul>
<a id="setRelative(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setRelative</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setRelative&#8203;(boolean&nbsp;value)</pre>
<div class="block">Sets the relative state of the geometry.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>value</code> - Boolean value to be used as the new relative state.</dd>
</dl>
</li>
</ul>
<a id="swap()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>swap</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;swap()</pre>
<div class="block">Swaps the x, y, width and height with the values stored in
 alternateBounds and puts the previous values into alternateBounds as
 a rectangle. This operation is carried-out in-place, that is, using the
 existing geometry instance. If this operation is called during a graph
 model transactional change, then the geometry should be cloned before
 calling this method and setting the geometry of the cell using
 mxGraphModel.setGeometry.</div>
</li>
</ul>
<a id="getTerminalPoint(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTerminalPoint</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;getTerminalPoint&#8203;(boolean&nbsp;isSource)</pre>
<div class="block">Returns the point representing the source or target point of this edge.
 This is only used if the edge has no source or target vertex.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>isSource</code> - Boolean that specifies if the source or target point
 should be returned.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the source or target point.</dd>
</dl>
</li>
</ul>
<a id="setTerminalPoint(hk.quantr.mxgraph.util.mxPoint,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTerminalPoint</h4>
<pre class="methodSignature">public&nbsp;<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;setTerminalPoint&#8203;(<a href="../util/mxPoint.html" title="class in hk.quantr.mxgraph.util">mxPoint</a>&nbsp;point,
                                boolean&nbsp;isSource)</pre>
<div class="block">Sets the sourcePoint or targetPoint to the given point and returns the
 new point.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>point</code> - Point to be used as the new source or target point.</dd>
<dd><code>isSource</code> - Boolean that specifies if the source or target point
 should be set.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the new point.</dd>
</dl>
</li>
</ul>
<a id="translate(double,double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>translate</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;translate&#8203;(double&nbsp;dx,
                      double&nbsp;dy)</pre>
<div class="block">Translates the geometry by the specified amount. That is, x and y of the
 geometry, the sourcePoint, targetPoint and all elements of points are
 translated by the given amount. X and y are only translated if the
 geometry is not relative. If TRANSLATE_CONTROL_POINTS is false, then
 are not modified by this function.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>dx</code> - Integer that specifies the x-coordinate of the translation.</dd>
<dd><code>dy</code> - Integer that specifies the y-coordinate of the translation.</dd>
</dl>
</li>
</ul>
<a id="clone()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>clone</h4>
<pre class="methodSignature">public&nbsp;java.lang.Object&nbsp;clone()</pre>
<div class="block">Returns a clone of the cell.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
<dd><code><a href="../util/mxRectangle.html#clone()">clone</a></code>&nbsp;in class&nbsp;<code><a href="../util/mxRectangle.html" title="class in hk.quantr.mxgraph.util">mxRectangle</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGeometry.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
